(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var ECMAScript = Package.ecmascript.ECMAScript;
var check = Package.check.check;
var Match = Package.check.Match;
var Accounts = Package['accounts-base'].Accounts;
var AccountsServer = Package['accounts-base'].AccountsServer;
var babelHelpers = Package['babel-runtime'].babelHelpers;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var AccountsUi, SandstormAccountSettingsUi;

(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                     //
// packages/sandstorm-accounts-ui/accounts-ui-server.js                                                //
//                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                               //
// All rights reserved.                                                                                //
//                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                     //
// you may not use this file except in compliance with the License.                                    //
// You may obtain a copy of the License at                                                             //
//                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                        //
//                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                            //
// See the License for the specific language governing permissions and                                 //
// limitations under the License.                                                                      //
                                                                                                       //
// Meteor permits users to modify their own profile by default, for some reason.                       //
Meteor.users.deny({                                                                                    // 18
  insert: function () {                                                                                // 19
    return true;                                                                                       // 19
  },                                                                                                   //
                                                                                                       //
  update: function () {                                                                                // 21
    return true;                                                                                       // 21
  },                                                                                                   //
                                                                                                       //
  remove: function () {                                                                                // 23
    return true;                                                                                       // 23
  },                                                                                                   //
                                                                                                       //
  fetch: []                                                                                            // 25
});                                                                                                    //
                                                                                                       //
Meteor.publish("getMyUsage", function () {                                                             // 28
  var db = this.connection.sandstormDb;                                                                // 29
  if (this.userId) {                                                                                   // 30
    // TODO(someday): Make this reactive.                                                              //
    var user = Meteor.users.findOne(this.userId);                                                      // 32
    var usage = db.getMyUsage(user);                                                                   // 33
    this.added("users", this.userId, {                                                                 // 34
      pseudoUsage: usage                                                                               // 35
    });                                                                                                //
  }                                                                                                    //
                                                                                                       //
  this.ready();                                                                                        // 39
});                                                                                                    //
/////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);






(function(){

/////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                     //
// packages/sandstorm-accounts-ui/accounts-ui-methods.js                                               //
//                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                       //
// Sandstorm - Personal Cloud Sandbox                                                                  //
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                               //
// All rights reserved.                                                                                //
//                                                                                                     //
// Licensed under the Apache License, Version 2.0 (the "License");                                     //
// you may not use this file except in compliance with the License.                                    //
// You may obtain a copy of the License at                                                             //
//                                                                                                     //
//   http://www.apache.org/licenses/LICENSE-2.0                                                        //
//                                                                                                     //
// Unless required by applicable law or agreed to in writing, software                                 //
// distributed under the License is distributed on an "AS IS" BASIS,                                   //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                            //
// See the License for the specific language governing permissions and                                 //
// limitations under the License.                                                                      //
                                                                                                       //
// This file contains method definitions which are available on both client and server (on the         //
// client for prediction purposes, on the server for actual execution).                                //
                                                                                                       //
var ValidHandle = Match.Where(function (handle) {                                                      // 20
  check(handle, String);                                                                               // 21
  return !!handle.match(/^[a-z_][a-z0-9_]*$/);                                                         // 22
});                                                                                                    //
                                                                                                       //
Meteor.methods({                                                                                       // 25
  updateProfile: function (identityId, profile) {                                                      // 26
    // TODO(cleanup): This check also appears in sandstorm-db/users.js.                                //
    check(identityId, String);                                                                         // 28
                                                                                                       //
    check(profile, {                                                                                   // 30
      name: String,                                                                                    // 31
      handle: ValidHandle,                                                                             // 32
      pronoun: Match.OneOf("male", "female", "neutral", "robot"),                                      // 33
      unverifiedEmail: Match.Optional(String)                                                          // 34
    });                                                                                                //
                                                                                                       //
    if (!this.userId) {                                                                                // 37
      throw new Meteor.Error(403, "not logged in");                                                    // 38
    }                                                                                                  //
                                                                                                       //
    var userToUpdate = Meteor.users.findOne({ _id: identityId });                                      // 41
                                                                                                       //
    if (!this.isSimulation && !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {
      throw new Meteor.Error(403, "identity is not linked to current user: " + identityId);            // 45
    }                                                                                                  //
                                                                                                       //
    var newValues = {                                                                                  // 48
      "profile.name": profile.name,                                                                    // 49
      "profile.handle": profile.handle,                                                                // 50
      "profile.pronoun": profile.pronoun                                                               // 51
    };                                                                                                 //
                                                                                                       //
    Meteor.users.update({ _id: userToUpdate._id }, { $set: newValues });                               // 54
                                                                                                       //
    if (!Meteor.user().hasCompletedSignup) {                                                           // 56
      Meteor.users.update({ _id: this.userId }, { $set: { hasCompletedSignup: true } });               // 57
    }                                                                                                  //
  },                                                                                                   //
                                                                                                       //
  testFirstSignup: function (profile) {                                                                // 61
    if (!this.userId) {                                                                                // 62
      throw new Meteor.Error(403, "not logged in");                                                    // 63
    }                                                                                                  //
                                                                                                       //
    Meteor.users.update(this.userId, { $unset: { hasCompletedSignup: "" } });                          // 66
  }                                                                                                    //
});                                                                                                    //
                                                                                                       //
if (Meteor.isClient) {                                                                                 // 70
  window.testFirstSignup = function () {                                                               // 71
    Meteor.call("testFirstSignup");                                                                    // 72
  };                                                                                                   //
}                                                                                                      //
                                                                                                       //
if (Meteor.isServer) {                                                                                 // 76
  // Methods that can't be simulated.                                                                  //
                                                                                                       //
  Meteor.methods({                                                                                     // 79
    uploadProfilePicture: function (identityId) {                                                      // 80
      check(identityId, String);                                                                       // 81
      if (!this.userId || !this.connection.sandstormDb.userHasIdentity(this.userId, identityId)) {     // 82
        throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);             // 83
      }                                                                                                //
                                                                                                       //
      return this.connection.sandstormDb.newAssetUpload({                                              // 86
        profilePicture: { userId: this.userId, identityId: identityId }                                // 87
      });                                                                                              //
    },                                                                                                 //
                                                                                                       //
    cancelUploadProfilePicture: function (id) {                                                        // 91
      check(id, String);                                                                               // 92
      this.connection.sandstormDb.fulfillAssetUpload(id);                                              // 93
    },                                                                                                 //
                                                                                                       //
    setPrimaryEmail: function (email) {                                                                // 96
      check(email, String);                                                                            // 97
      if (!this.userId) {                                                                              // 98
        throw new Meteor.Error(403, "Not logged in.");                                                 // 99
      }                                                                                                //
                                                                                                       //
      var emails = SandstormDb.getUserEmails(Meteor.user());                                           // 102
      if (!_.findWhere(emails, { email: email, verified: true })) {                                    // 103
        throw new Meteor.Error(403, "Not a verified email of the current user: " + email);             // 104
      }                                                                                                //
                                                                                                       //
      Meteor.users.update({ _id: this.userId }, { $set: { primaryEmail: email } });                    // 107
    }                                                                                                  //
  });                                                                                                  //
}                                                                                                      //
/////////////////////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['sandstorm-accounts-ui'] = {
  AccountsUi: AccountsUi,
  SandstormAccountSettingsUi: SandstormAccountSettingsUi
};

})();

//# sourceMappingURL=sandstorm-accounts-ui.js.map
